 Crash Course into BWM

Mechanical Power is a simple gear-based system that can be used for many complex machines.

The first step to Mechanical Power is the Hand Crank. This allows for manually powering certain machines directly, like the Millstone, for early production of further resources and parts.

The next step is to make continuous Mechanical Power through a Windmill, to do this a strong fibrous material is necessary. Hemp is exactly that, put this plant into the Millstone to create Hemp Fibers, to make Rope or Fabric. You can obtain Hemp from Hemp Seeds, which need sunlight directly above them, at this point in the tech tree.

To cut down on the wait time for grinding hemp, you could place down more Millstones and hand cranks, allowing for you to alternate along a set of them, reducing your wait time.

Once enough Hemp Fiber is gathered, create a Windmill to create continuous Mechanical Power. The Windmill must be placed on an Axle and needs a 13x13 vertical area to be placed successfully.

Now that you have a [Windmill](../blocks/windmill.md), you must use Axles and Gearboxes to transfer Mechanical Power to as many machines as needed. Be careful though, the Windmill has one major downside; When the Weather gets too rough, the Windmill will rotate faster; this will eventually cause the first Gearbox connected to be overpowered and break. (Check Gearbox for more information.)

Alternatively, the [Vertical Windmill](../blocks/windmill.md) is also an option, which is a slightly more expensive windmill that needs a 9x7x9 area cleared, with 7 vertical axles. It's advantages are that, other than allowing different axle placement methods, it works in the Nether and underground in the overworld, whereas the normal Windmill does not. Do note that if you try to place an axle off of this windmill directly, it'll break off. You need to have it directly hooked into it's first gearbox.

![Basic Mechanical Power](betterwithmods:mechanical-power.png)

With Continuous Mechanical Power now being produced, more machines are available to use.

The next step to using Mechanical Power is Tanned Leather, which is created in a Cauldron. You need wood bark and scoured leather for this process, which the millstone can provide you with scoured leather, and as for the wood bark, taking an axe to wood logs as a crafting recipe, or simply punching a tree will work. Alternatively, if you have dung... It also works in lieu of bark.

A [Cauldron](../blocks/cauldron.md) requires a uninterrupted fire source in below it, this can be from burning netherrack or wood if you're really desperate. Additionally, the more fire in the 3x3 around the center fire the faster the Cauldron will process. Having a functional Cauldron opens up more possibilities, such as the creation of Heating Elements and Filaments; This allows creating the Hibachi and [Light Blocks](../blocks/light.md) respectively. The cauldron also allows mass cooking of food and more. It's best to imagine it as a furnace that can cook certain things over time; Place stuff in, and go about your business, and return after a long day's work to check the pot!

The Cauldron also accepts stuff being dropped in from the top, and when powered by mechanical power, will tip the contents out!

With Tanned Leather, Leather Belts can now be made to create more complex machines:
 * The Saw gives access to better Log cutting as well as creating Minimized Wood for making more complex wooden items, or it can be used to automatically kill mobs with an increased chance for loot to drop from them. This machine requires continuous mechanical power.
 * The Filtered Hopper is a multi-purpose machine that can pick up items on top of it and be filtered with certain items to allow specified groups of items through (Find more in Hopper Filters). It is required to create Hellfire Dust and later Soul Urns. It can accept mechanical power as an option.

* The [Hibachi](../blocks/hibachi.md) is a redstone control fire sourced fueled from the raw energy inside [Concretrated Hellfire](../items/hellfire.md) created in an **Unstoked** Cauldron (Put hellfire into a Stoked Cauldron at your own risk, you were warned.)

*  The [Bellows](../blocks/bellows.md) is an air bladder that, when given mechanical power, will contract and blow a gust at the 3x3 block area in front of it, and will expand when the mechanical power is removed. This gust of air can be used to stoke the fires of a Hibachi, allowing the Cauldron and the Crucible to process Stoked Recipes as well as create a Kiln.

To properly stoke a fire, one must alternate the power to a Bellows enough for it go up and down before the fire cools back down. This timing can be achieved with the [Turntable](../blocks/turntable.md) or if you want, a normal redstone timer. The specifics will be left to you, the player, to discover.

Stoked Cauldron:

![Basic Stoked Cauldron](betterwithmods:stoking.png)

Stoked Cauldrons are used for processing ingredients into advanced recipes, such as rendering leather into glue, wood into potash, and meat into tallow.
 * Glue is oredicted for slimeballs, so this can act as a suitable replacement in recipes that call for it, in addition to having it's own uses beyond just being a slimeball substitute.
 * Tallow can be used for making [Candles](../blocks/candles.md), [Blasting Oil](../items/blasting_oil.md), and finally, [Soap](../items/soap.md).
 * Potash's main use is to combine with hellfire dust to make Nether Sludge, which can be smelted in the furnace or kiln as a more efficient source of Nether Brick.

With access to glue, one can now make the Waterwheel. This mechanical generator requires flowing water in order to produce mechanical power. It's biggest advantages are that it can avoid being overpowered by weather conditions, and that you can now get underground mechanical power without a very long chain of axles and gearboxes. It also is your only source of mechanical power in The End, for automating Enderman farms or whatever else you might need mechanical power there for.

The [Kiln](../blocks/kiln.md) is a multiblock structure that requires a single bottom Bricks and 3 additional Bricks around the air above the bottom block. Kilns can shared Bricks.

Each of these Hibachis has a valid kiln shape above it.

Basic Kilns:

![Kiln Structures](betterwithmods:kilns.png)

Like the crucible and cauldron, it is also boosted by adding more fire underneth it in a 3x3 section.
To use the kiln place a block with a recipe into the air above the bottom block and it will begin to smelt it.

Uses of the kiln:
 * Baking raw clay pottery into actual, usable solid pottery; This is so you can obtain the [Crucible](../blocks/crucible.md).
 * Another other use is for mass baking of cookies, pies, bread, and cakes in more efficient recipes than the crafting table by placing their raw variants into the kiln.
 * It's other big use is producing White Cobble from Endstone. This is one key link for making [Soulforged Steel](../items/soulforged_steel.md); It produces the Ender Slag required for producing [Soul Flux](../items/soul_flux.md).
 * Finally, you can make charcoal in it. Just toss any ol' log in there and it'll begin turning into that sweet, sweet renewable coal variant!

The Stoked [Crucible](../blocks/crucible.md) is a highly important block. When stoked it allows for the following:

 * The creation of [Soulforged Steel](../items/soulforged_steel.md), the most important lategame material by far.
 * Mass smelting of various furnace recipes (But not food cooking.), like sand into glass, cobble into smooth stone, and so on.
 * Somewhat lossy recycling of various tools, armors, and other mostly metal blocks. Diamond/Soulforged Steel items and armor recycle at a 100% return, and is the best way to continually get new gear of those types!
 * Automatic recombination of nuggets into ingots (Mainly for the above.)

The Crucible accepts stuff being dropped into the top, much like the Cauldron!

