package betterwithmods.client.gui;


import betterwithmods.common.penalties.BasicPenalty;
import betterwithmods.module.hardcore.needs.hunger.HCHunger;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.MobEffects;
import net.minecraft.util.FoodStats;
import net.minecraftforge.client.GuiIngameForge;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.Random;

/**
 * GUI for hunger levels and player penalties.
 *
 * @author Koward
 */
public class GuiHunger {

    public static GuiHunger INSTANCE = new GuiHunger();
    private final Random rand = new Random();
    private final Minecraft mc = Minecraft.func_71410_x();
    private int shakeCounter = 0;
    private boolean shakeTriggered;

    @SideOnly(Side.CLIENT)
    public void draw() {
        ScaledResolution scale = ((GuiIngameForge) mc.field_71456_v).getResolution();

        int left = scale.func_78326_a() / 2 + 91;
        int top = scale.func_78328_b() - GuiIngameForge.right_height;

        drawFoodOverlay(left, top);
    }

    @SuppressWarnings("Duplicates")
    @SideOnly(Side.CLIENT)
    private void drawFoodOverlay(int left, int top) {
        EntityPlayer player = this.mc.field_71439_g;
        FoodStats foodStats = player.func_71024_bL();
        int food = foodStats.func_75116_a();
        int fat = (int) foodStats.func_75115_e();

        int roll = fat / 6;
        int shank = food / 6;

        if (shakeTriggered) {
            this.shakeCounter = 20;
            shakeTriggered = false;
        } else if (shakeCounter > 0) {
            --this.shakeCounter;
        }

        GlStateManager.func_179147_l();
        for (int i = 0; i < 10; ++i) {
            int y = top;
            int icon = 16;
            byte background = 0;
            if (player.func_70644_a(MobEffects.field_76438_s)) {
                icon += 36;
                background = 13;
            } else if (i < roll) {
                background = 1;
            }

            BasicPenalty<Integer> p = HCHunger.penalties.getPenalty(player);
            if (p != null && p.getSeverity() > 0 && mc.field_71456_v.func_73834_c() % (food * 5 + 1) == 0) {
                y = top + (rand.nextInt(3) - 1);
            } else if (shakeCounter > 0) {
                y = top + (rand.nextInt(3) - 1);
            }

            int x = left - i * 8 - 9;

            mc.field_71456_v.func_73729_b(x, y, 16 + background * 9, 27, 9, 9);

            int remainder;
            if (i == roll && !player.func_70644_a(MobEffects.field_76438_s)) {
                remainder = fat % 6;
                if (remainder != 0) {
                    mc.field_71456_v.func_73729_b(x + 8 - remainder, y, 33 - remainder,
                            27, 1 + remainder, 9);
                }
            }

            if (i < shank) {
                mc.field_71456_v.func_73729_b(x, y, icon + 36, 27, 9, 9);
            } else if (i == shank) {
                remainder = food % 6;
                if (remainder != 0) {
                    mc.field_71456_v.func_73729_b(x + 7 - remainder, y, icon + 36 + 7
                            - remainder, 27, 3 + remainder, 9);
                }
            }
        }

        GlStateManager.func_179084_k();
        GuiIngameForge.right_height += 10;
    }

    public void shake() {
        this.shakeTriggered = true;
    }
}
